import{LitElement,css,html$1 as html,PageViewElement,connect,store,SharedStyles,formDataToJson,appurl,fetchResource,addMessage,readMessagesInInjury,readMessagesInAthlete,addAthlete,addInjury$1 as addInjury,newIncomingMessage,$inboxDefault as inbox}from"./my-app.js";class InboxContent extends connect(store)(LitElement){static get properties(){return{user:{type:Number},currentAthleteId:{type:String},currentInjuryId:{type:String},messages:{type:Object}}}static get styles(){return[SharedStyles,css`
      /* This was .inbox*/
        :host {
          display: flex;
          flex-direction: column;
          justify-content: space-between;
        }
        .messages {
          max-height: calc(100vh - 310px);
          max-height: -moz-calc(100vh - 310px);
          max-height: -webkit-calc(100vh - 310px);
          min-height: calc(100vh - 310px);
          min-height: -moz-calc(100vh - 310px);
          min-height: -webkit-calc(100vh - 310px);
          overflow-y: scroll;
          transform: rotate(180deg);
          direction: rtl;
          text-align: left;
        }
        .messages-inside {
          overflow:hidden;
          transform: rotate(180deg);
          direction: ltr;
        }
        .message-container {
          padding: 5px 0 5px 0;;
          display: flex;
          flex-direction: column;
          border-bottom: 1px solid #eee;
        }
        .message-container:last-of-type {
          border-bottom: 0px;
        }
        .message-from {
          display: flex;
          flex-direction: row;
          justify-content: space-between;
        }
        .message-content {
          padding: 3px 0 0 5px;
        }

        .input-app-button {
          padding: 5px 0;
          width: 70px;
          margin: 0;
        }
        .inbox-new-message {
          margin-top: 10px;
        }
        textarea {
          border: 1px solid #eee;
        }
        .date {
          color: var(--secondary-color);
          font-weight: none;
        }
        .from {
          font-weight: bold;
        }

      `]}render(){return html`
            <div class="messages" id="messages-container">
              <div class="messages-inside">
              ${Object.keys(this.messages).map(mKey=>{if("0"!==mKey){return html`
                    <div class="message-container" id=${this.messages[mKey].id}>
                      <div class="message-from"><div class="from">${this.messages[mKey].from}</div><div class="date">${this.messages[mKey].date}</div></div>
                      <div class="message-content">${this.messages[mKey].content}</div>
                    <div>
                  `}})}
              </div>
            </div>
            <form class="inbox-new-message" id="new-message" @submit="${this._submitForm}">
              <input type="hidden" name="from" value="${this.user}">
              <input type="hidden" name="to" value="${this.currentAthleteId}">
              <input type="hidden" name="injury" value="${this.currentInjuryId}">
              <textarea id="textbox" form="new-message" name="message" rows="3" cols="30"></textarea>
              <input type="submit" class="input-app-button" value="Send">
            </form>
    `}async _submitForm(event){const formElement=this.shadowRoot.getElementById("new-message"),jsonFormData=formDataToJson(formElement),url=appurl+"/api/inbox",fetchOptions={method:"POST",headers:{"Content-Type":"application/json"},body:jsonFormData};store.dispatch(fetchResource(url,fetchOptions)).then(()=>{const data=store.getState().resources.data;if("OK"==data.status){//store.dispatch(addMessage(data.message));
if(!firebase.messaging.isSupported()){store.dispatch(addMessage(data.message))}this.shadowRoot.getElementById("textbox").value=""}else{console.log("error")}});event.preventDefault()}}window.customElements.define("inbox-content",InboxContent);store.addReducers({inbox});class InboxOverview extends connect(store)(PageViewElement){static get properties(){return{_user:{type:Number},_userType:{type:Number},_currentAthleteId:{type:Number},_currentInjuryId:{type:String},_currentInboxId:{type:String},_athletes:{type:Object},_injuries:{type:Object},_messages:{type:Object},_unreadInjuries:{type:Object},_unreadAthletes:{type:Object}}}constructor(){super();this._currentInjuryId="i0";this._currentInboxId="i0";this._currentAthleteId=0}static get styles(){return[SharedStyles,css`
        .page-wide-content-container {
          display: flex;
          flex-direction: row;
          justify-content: flex-start;
          min-height: calc(100vh - 210px);
          min-height: -moz-calc(100vh - 210px);
          min-height: -webkit-calc(100vh - 210px);
        }

        .inbox-info {
          flex-basis: 25%;
          margin-right: 10px;
          border-right: 1px solid #eee;
          max-height: calc(100vh - 210px);
          max-height: -moz-calc(100vh - 210px);
          max-height: -webkit-calc(100vh - 210px);
          overflow-y: scroll;
        }
        .inbox-content {
          flex-basis: 75%;
          padding: 14px;
          display: flex;
          flex-direction: column;

        }
        .user-container {
          display: flex;
          flex-direction: column;
          border-bottom: none;
        }
        .user-info, .injury {
          cursor: pointer;
        }
        .injury {
          padding: 5px 0 0 5px;
          margin-bottom: 5px;
        }
        .inbox {
          min-height: calc(100vh - 210px);
          min-height: -moz-calc(100vh - 210px);
          min-height: -webkit-calc(100vh - 210px);
          display: flex;
          flex-direction: column;
          justify-content: space-between;
        }
        .email {
          color: var(--dark-sand-color);
        }

      `]}render(){return html`
    <div class="page-wide-content-container">

      <div class="inbox-info">
        ${!this._isObjectEmpty(this._athletes)?Object.keys(this._athletes).map(key=>{const mainInboxId=this._setMainInboxId(this._athletes[key].user_id),mainInboxButton=mainInboxId.concat("button"),fontWeight="undefined"!==typeof this._unreadAthletes[key]?"font-weight:"+this._unreadAthletes[key]+";":"font-weight:"+"normal"+";";return html`
            <div class="user-container">
              <div class="user-info" @click="${this._displayChosenAthletesInjuries}" data-index="${this._athletes[key].user_id}">
                            <div id=${mainInboxButton} style="${fontWeight}">
                              ${this._user==this._athletes[key].user_id?html`Hovedtråd`:html`${this._athletes[key].first_name} ${this._athletes[key].last_name}`}
                            </div>
                            <div class="email">
                              ${this._user==this._athletes[key].user_id?html``:html`${this._athletes[key].email}`}
                            </div>
              </div>
              <div class="injuries" style="display:none;" id="${this._athletes[key].user_id}">
                Skader:
                ${Object.keys(this._athletes[key].injuries).map(iKey=>{if("0"!==iKey){const inboxId=this._setInjuryId(this._injuries[iKey].injury_id),injuryId=inboxId.concat("button"),fontWeight="undefined"!==typeof this._unreadInjuries[iKey]?"font-weight:"+this._unreadInjuries[iKey]+";":"font-weight:"+"normal"+";";return html`
                      <div class="injury" id=${injuryId} @click="${this._displayChosenMessage}" data-index="${inboxId}" style="${fontWeight}">
                        ${this._injuries[iKey].title}
                      </div>
                    `}})}
              </div>
            </div>
          `}):Object.keys(this._injuries).map(key=>{const inboxId=this._setInjuryId(this._injuries[key].injury_id);return html`
              <div class="injury" @click="${this._displayChosenMessage}" data-index="${inboxId}">${this._injuries[key].title}</div>
          `})}
      </div>

      <div class="inbox-content" id="inbox-content">
        <div class="inbox" style="display:block;" id="i0">
          velg en meldings-tråd
        </div>
        ${Object.keys(this._athletes).map(key=>{const inboxId=this._setMainInboxId(this._athletes[key].user_id),messages={};let lastMessage;Object.keys(this._athletes[key].messages).map(mKey=>{messages[mKey]=this._messages[mKey]});return html`
          <inbox-content style="display:none;" id="${inboxId}" .user="${this._user}"
                        .currentAthleteId="${this._athletes[key].user_id}"
                        .currentInjuryId="0"
			.messages="${messages}"></inbox-content>

        `})}
        ${Object.keys(this._injuries).map(key=>{const inboxId=this._setInjuryId(this._injuries[key].injury_id),messages={};Object.keys(this._injuries[key].messages).map(mKey=>{messages[mKey]=this._messages[mKey]});return html`
          <inbox-content style="display:none;" id="${inboxId}" .user="${this._user}"
                        .currentInjuryId="${this._injuries[key].injury_id}"
                        .currentAthleteId="0"
			.messages="${messages}"></inbox-content>

        `})}
      </div>

    </div>
    `}_setInjuryId(id){const iId="i"+id;return iId}_setMainInboxId(id){const iId="a"+id;return iId}_isObjectEmpty(Obj){for(var key in Obj){if(Obj.hasOwnProperty(key)){return!1}}return!0}_displayChosenMessage(e){if(this._unreadInjuries[+e.currentTarget.dataset.index.slice(1)]){const athleteInboxId=Object.keys(this._athletes).filter(key=>0<Object.keys(this._athletes[key].injuries).filter(i=>i==+e.currentTarget.dataset.index.slice(1)).length);this._readMessage(e.currentTarget.dataset.index.slice(1),"injury");store.dispatch(readMessagesInInjury(+e.currentTarget.dataset.index.slice(1)))}this.shadowRoot.getElementById(this._currentInboxId).style.display="none";if(e.currentTarget.dataset.index.startsWith("i")){this._currentInboxId=e.currentTarget.dataset.index}else{this._currentInboxId="a"+e.currentTarget.dataset.index}this.shadowRoot.getElementById(this._currentInboxId).style.display="block"}_displayChosenAthletesInjuries(e){this._readMessage(e.currentTarget.dataset.index.slice(1),"athlete");if(this._unreadAthletes[e.currentTarget.dataset.index]){this._readMessage(e.currentTarget.dataset.index,"athlete");store.dispatch(readMessagesInAthlete(e.currentTarget.dataset.index))}if(0!==this._currentAthleteId){if(this._currentAthleteId!==+e.currentTarget.dataset.index){this.shadowRoot.getElementById(this._currentAthleteId.toString()).style.display="none"}this.shadowRoot.getElementById(this._currentInboxId).style.display="none";this._currentInboxId="a"+e.currentTarget.dataset.index;this.shadowRoot.getElementById(this._currentInboxId).style.display="block"}if(this._currentAthleteId==+e.currentTarget.dataset.index){//this.shadowRoot.getElementById(this._currentAthleteId.toString()).style.display = "none";
//this._currentAthleteId = 0;
this.shadowRoot.getElementById(this._currentInboxId).style.display="none";this._currentInboxId="a"+this._currentAthleteId;this.shadowRoot.getElementById(this._currentInboxId).style.display="block"}else{this._currentAthleteId=+e.currentTarget.dataset.index;this.shadowRoot.getElementById(this._currentAthleteId.toString()).style.display="block";// display chosen athletes main inbox thread
this.shadowRoot.getElementById(this._currentInboxId).style.display="none";this._currentInboxId="a"+e.currentTarget.dataset.index;this.shadowRoot.getElementById(this._currentInboxId).style.display="block"}}async firstUpdated(){const url=appurl+"/api/inbox/"+this._user,fetchOptions={method:"GET"};store.dispatch(fetchResource(url,fetchOptions)).then(()=>{const data=store.getState().resources.data;if("OK"==data.status){Object.keys(data.athletes).map(key=>{store.dispatch(addAthlete(data.athletes[key]))});Object.keys(data.injuries).map(key=>{store.dispatch(addInjury(data.injuries[key]))});Object.keys(data.messages).map(key=>{store.dispatch(addMessage(data.messages[key]))});Object.keys(data.newMessages).map(key=>{store.dispatch(newIncomingMessage(key))})}else{// TODO handle error
console.log("error")}})}stateChanged(state){if(this._messages!==state.inbox.messages){this._messages=state.inbox.messages}if(this._user!==state.session.userID){this._user=state.session.userID}if(this._userType!==state.session.userType){this._userType=state.session.userType}this._athletes=state.inbox.athletes;this._injuries=state.inbox.injuries;if(this._unreadAthletes!==state.inbox.unreadAthletes){this._unreadAthletes=state.inbox.unreadAthletes}if(this._unreadInjuries!==state.inbox.unreadInjuries){this._unreadInjuries=state.inbox.unreadInjuries}}async _readMessage(inbox,type){//const formElement = this.shadowRoot.getElementById("injuryEdit");
const jsonFormData=`{"id":"${this._user}","inbox":"${inbox}","type":"${type}"}`,url=appurl+"/api/inbox",fetchOptions={method:"PUT",headers:{"Content-Type":"application/json"},body:jsonFormData};store.dispatch(fetchResource(url,fetchOptions))}}window.customElements.define("inbox-overview",InboxOverview);