const fs = require("fs");
const mariadb = require("mariadb");

// Read certificates from files
const cafile = [fs.readFileSync("openssl/ca.pem", "utf8")];
const certfile = [fs.readFileSync("openssl/client-cert.pem", "utf8")];
const keyfile = [fs.readFileSync("openssl/client-key.pem", "utf8")];
const password = fs.readFileSync("mysql/mysql_pwd", "utf8").trim(); // Remove newline at end

const pool = mariadb.createPool({
  user: "user",
  host: "db",
  password: password,
  database: "appdb",
  ssl: {
      rejectUnauthorized: false, // For self signed cert, do not use in prod!
      ca: cafile,
      cert: certfile,
      key: keyfile
  },
  connectionLimit: 5,
  rowsAsArray: false
});

// This connection pool is imported in all files that need to query the database
module.exports = pool;
