export const LOGIN = 'LOGIN';
export const LOGOUT = 'LOGOUT';

/*
  The login action creator starts a session with a lifetime of 3 weeks.
  This is saved to both state and local storage. When a new browser session is started,
  local storage is loaded into state and the expiration time is checked against the current time.
*/
export const logIn = (uid, utype) => {
  return {
    type: LOGIN,
    userID: uid,
    userType: utype,
    expires: Date.now() + 1814400000 // 3 weeks
  };
};

export const logOut = () => {
  return {
    type: LOGOUT,
    userID: null,
    userType: null,
    expires: null
  };
};
