import 'formdata-polyfill';

/*
  Takes a HTML form element, gets its current values and constructs a JSON string from it.
  Assumes simple key-value pairs. Values that contain objects or arrays are copied as is.
  The result can be put in a request body and sent to the server.
*/
export function formDataToJson(formElement) {
  const formData = new FormData(formElement);
  var json = '{';
  for (var pair of formData.entries()) {
    json += ('"' + pair[0] + '"' + ':"' + pair[1] + '",');
  }
  json = json.slice(0,-1); // Remove final comma
  json += '}';
  return json;
}
