import { LOGIN, LOGOUT } from '../actions/session.js';

const INITIAL_STATE = {
  loggedIn: false,
  userID: null,
  userType: null,
  expires: null
};

const session = (state = INITIAL_STATE, action) => {
  switch (action.type) {
    case LOGIN:
      return {
        loggedIn: true,
        userID: action.userID,
        userType: action.userType,
        expires: action.expires
      };
    case LOGOUT:
      return {
        loggedIn: INITIAL_STATE.loggedIn,
        userID: INITIAL_STATE.userID,
        userType: INITIAL_STATE.userType,
        expires: INITIAL_STATE.expires
      };
    default:
      return state;
  };
};

export default session;
